/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.STCMCUDATA.com  ---------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ            */
/*---------------------------------------------------------------------*/

#include	"config.h"
#include	"STC8A_GPIO.h"
#include	"STC8A_ADC.h"
#include	"STC8A_UART.h"
#include	"STC8A_Delay.h"
#include	"STC8A_NVIC.h"

/*************	˵	**************

ʾ16·ADCѯͨڷ͸λ115200,N,8,1

öʱʷʹ1Tģʽ(ǵͲ12T)ѡɱʱƵʣ߾ȡ

ʱ, ѡʱ 22.1184MHz (ļ"config.h"޸).

******************************************/


/*************	س	**************/


/*************	ر	**************/


/*************	غ	**************/


/*************  ⲿͱ *****************/


/******************* IOú *******************/
void	GPIO_config(void)
{
	P0_MODE_IN_HIZ(GPIO_Pin_LOW | GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6);		//P0.0~P0.6 Ϊ
	P1_MODE_IN_HIZ(GPIO_Pin_All);		//P1.0~P1.7 Ϊ
	P3_MODE_IO_PU(GPIO_Pin_0 | GPIO_Pin_1);	//P3.0,P3.1 Ϊ׼˫
}

/******************* ADú *******************/
void	ADC_config(void)
{
	ADC_InitTypeDef		ADC_InitStructure;		//ṹ
	ADC_InitStructure.ADC_SMPduty   = 31;		//ADC ģźŲʱ, 0~31ע⣺ SMPDUTY һС 10
	ADC_InitStructure.ADC_CsSetup   = 0;		//ADC ͨѡʱ 0(Ĭ),1
	ADC_InitStructure.ADC_CsHold    = 1;		//ADC ͨѡ񱣳ʱ 0,1(Ĭ),2,3
	ADC_InitStructure.ADC_Speed     = ADC_SPEED_2X1T;		// ADC ʱƵ	ADC_SPEED_2X1T~ADC_SPEED_2X16T
	ADC_InitStructure.ADC_AdjResult = ADC_RIGHT_JUSTIFIED;	//ADC,	ADC_LEFT_JUSTIFIED,ADC_RIGHT_JUSTIFIED
	ADC_Inilize(&ADC_InitStructure);		//ʼ
	ADC_PowerControl(ENABLE);						//ADCԴ, ENABLEDISABLE
	NVIC_ADC_Init(DISABLE,Priority_0);		//жʹ, ENABLE/DISABLE; ȼ(͵) Priority_0,Priority_1,Priority_2,Priority_3
}

/***************  ڳʼ *****************/
void	UART_config(void)
{
	COMx_InitDefine		COMx_InitStructure;					//ṹ
	COMx_InitStructure.UART_Mode      = UART_8bit_BRTx;		//ģʽ,   UART_ShiftRight,UART_8bit_BRTx,UART_9bit,UART_9bit_BRTx
	COMx_InitStructure.UART_BRT_Use   = BRT_Timer1;			//ʹò, BRT_Timer1, BRT_Timer2 (ע: 2̶ʹBRT_Timer2)
	COMx_InitStructure.UART_BaudRate  = 115200ul;			//,     110 ~ 115200
	COMx_InitStructure.UART_RxEnable  = ENABLE;				//,   ENABLEDISABLE
	UART_Configuration(UART1, &COMx_InitStructure);		//ʼ2 USART1,USART2,USART3,USART4
	NVIC_UART1_Init(ENABLE,Priority_1);		//жʹ, ENABLE/DISABLE; ȼ(͵) Priority_0,Priority_1,Priority_2,Priority_3
}

/**********************************************/
void main(void)
{
	u8	i;
	u16	j;

	GPIO_config();
	UART_config();
	ADC_config();
	EA = 1;

	printf("STC8 AD to UART Test Programme!\r\n");	//UARTһַ

	while (1)
	{
		for(i=0; i<16; i++)
		{
			delay_ms(200);

			//Get_ADCResult(i);		//0~15,ѯʽһADC, һ
			j = Get_ADCResult(i);	//0~15,ѯʽһADC, ֵǽ, == 4096 Ϊ
			printf("AD%02bd=%04d ",i,j);
			if((i & 7) == 7)	printf("\r\n");
		}
		printf("\r\n");
	}
}



